/* $Id: textview.c,v 1.1 1998/04/03 07:33:30 kjc Exp kjc $ */
/*
 *  Copyright (c) 1996
 *	Sony Computer Science Laboratory Inc.  All rights reserved.
 *
 * Redistribution and use in source and binary forms of parts of or the
 * whole original or derived work are permitted provided that the above
 * copyright notice is retained and the original work is properly
 * attributed to the author. The name of the author may not be used to
 * endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */
/* textview.c -- a text-based viewer program.  just for debug */
#include <stdio.h>
#include <netdb.h>
#include <sys/param.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>

#include "ttt.h"
#include "ttt_node.h"
#include "ttt_remote.h"

static int sockfd;

int main(int argc, char **argv)
{
    view_parseargs(argc, argv);

    sockfd = view_opensock();

    while (1) {
	view_sockread(sockfd, 0);
    }

    view_closesock(sockfd);
}

void ttt_textview(int seq_no)
{
    struct t_node *np;
    int i;
    double cur_time, last_time, sec, kbps, get_timeindouble();
    u_long recvpkts, droppkts, lostpkts;
    extern char *class_getname();

    cur_time = get_timeindouble();
    if (seq_no == 0)
	last_time = cur_time;
	
    sec = cur_time - last_time;
    if (sec == 0.0)
	sec = 0.1;

    printf("[TRAFFIC at time %.2f]\n", cur_time);

    for (i=0, np = node_getbiggest(TTTTYPE_PROTO);
	 i<10 && np != NULL; i++, np = node_getnext(np)) {

	if (i == 0)
	    printf("  Throughput:\n");

	kbps = (double)np->t_size * 8.0 / sec / 1000.0;

	printf("    %s:\t%8.2f Kbps\n",
	       class_getname(np->t_type, np->t_id), kbps);
    }
    for (i=0, np = node_getbiggest(TTTTYPE_HOST);
	 i<10 && np != NULL; i++, np = node_getnext(np)) {

	if (i == 0)
	    printf("  Dropped Rate:\n");
	
	kbps = (double)np->t_size * 8.0 / sec / 1000.0;

	printf("    %s:\t%8.2f Kbps\n",
	       class_getname(np->t_type, np->t_id), kbps);
    }
    
    printf("\n");

    last_time = cur_time;
    node_bumptime();
}
